VTK: vtkTextureObject Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkTextureObject Class Reference

abstracts an OpenGL texture object. More...

`#include <vtkTextureObject.h>`

Inheritance diagram for vtkTextureObject:
[legend]
Collaboration diagram for vtkTextureObject:
[legend]

## Public Types
enum | { Lequal = 0 , Gequal , Less , Greater , Equal , NotEqual , AlwaysTrue , Never , NumberOfDepthTextureCompareFunctions }
enum | { ClampToEdge = 0 , Repeat , MirroredRepeat , ClampToBorder , NumberOfWrapModes }
enum | { Nearest = 0 , Linear , NearestMipmapNearest , NearestMipmapLinear , LinearMipmapNearest , LinearMipmapLinear , NumberOfMinificationModes }
enum | { Native = 0 , Fixed8 , Fixed16 , Fixed24 , Fixed32 , Float16 , Float32 , NumberOfDepthFormats }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkTextureObject * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual int | GetNumberOfDimensions ()
virtual void | SetSamples (unsigned int)
int | GetTextureUnit ()
| Return the texture unit used for this texture. More...
virtual void | Activate ()
| Activate and Bind the texture. More...
void | Deactivate ()
| Deactivate and UnBind the texture. More...
virtual void | ReleaseGraphicsResources (vtkWindow *win)
| Deactivate and UnBind the texture. More...
bool | IsBound ()
| Tells if the texture object is bound to the active texture image unit. More...
void | SendParameters ()
| Send all the texture object parameters to the hardware if not done yet. More...
bool | Create2DFromRaw (unsigned int width, unsigned int height, int numComps, int dataType, void *data)
| Create a 2D texture from client memory numComps must be in [1-4]. More...
bool | CreateDepthFromRaw (unsigned int width, unsigned int height, int internalFormat, int rawType, void *raw)
| Create a 2D depth texture using a raw pointer. More...
bool | CreateTextureBuffer (unsigned int numValues, int numComps, int dataType, vtkOpenGLBufferObject *bo)
| Create a texture buffer basically a 1D texture that can be very large for passing data into the fragment shader. More...
bool | EmulateTextureBufferWith2DTextures (unsigned int numValues, int numComps, int dataType, vtkOpenGLBufferObject *bo)
| Emulates a texture buffer with 2D texture. More...
bool | CreateCubeFromRaw (unsigned int width, unsigned int height, int numComps, int dataType, void *data[6])
| Create a cube texture from 6 buffers from client memory. More...
bool | Create1D (int numComps, vtkPixelBufferObject *pbo, bool shaderSupportsTextureInt)
| Create a 1D texture using the PBO. More...
bool | Create1DFromRaw (unsigned int width, int numComps, int dataType, void *data)
| Create 1D texture from client memory. More...
bool | Create2D (unsigned int width, unsigned int height, int numComps, vtkPixelBufferObject *pbo, bool shaderSupportsTextureInt)
| Create a 2D texture using the PBO. More...
bool | Create3D (unsigned int width, unsigned int height, unsigned int depth, int numComps, vtkPixelBufferObject *pbo, bool shaderSupportsTextureInt)
| Create a 3D texture using the PBO. More...
bool | Create3DFromRaw (unsigned int width, unsigned int height, unsigned int depth, int numComps, int dataType, void *data)
| Create a 3D texture from client memory numComps must be in [1-4]. More...
bool | AllocateProxyTexture3D (unsigned int width, unsigned int height, unsigned int depth, int numComps, int dataType)
| Create a 3D texture using the GL_PROXY_TEXTURE_3D target. More...
vtkPixelBufferObject * | Download ()
| This is used to download raw data from the texture into a pixel buffer. More...
vtkPixelBufferObject * | Download (unsigned int target, unsigned int level)
bool | CreateDepth (unsigned int width, unsigned int height, int internalFormat, vtkPixelBufferObject *pbo)
| Create a 2D depth texture using a PBO. More...
bool | AllocateDepth (unsigned int width, unsigned int height, int internalFormat)
| Create a 2D depth texture but does not initialize its values. More...
bool | AllocateDepthStencil (unsigned int width, unsigned int height)
| Create a 2D septh stencil texture but does not initialize its values. More...
bool | Allocate1D (unsigned int width, int numComps, int vtkType)
| Create a 1D color texture but does not initialize its values. More...
bool | Allocate2D (unsigned int width, unsigned int height, int numComps, int vtkType, int level=0)
| Create a 2D color texture but does not initialize its values. More...
bool | Allocate3D (unsigned int width, unsigned int height, unsigned int depth, int numComps, int vtkType)
| Create a 3D color texture but does not initialize its values. More...
int | GetVTKDataType ()
| Get the data type for the texture as a vtk type int i.e. More...
void | ResetFormatAndType ()
| Reset format, internal format, and type of the texture. More...
unsigned int | GetMinificationFilterMode (int vtktype)
unsigned int | GetMagnificationFilterMode (int vtktype)
unsigned int | GetWrapSMode (int vtktype)
unsigned int | GetWrapTMode (int vtktype)
unsigned int | GetWrapRMode (int vtktype)
void | SetLinearMagnification (bool val)
| Tells if the magnification mode is linear (true) or nearest (false). More...
bool | GetLinearMagnification ()
void | CopyFromFrameBuffer (int srcXmin, int srcYmin, int dstXmin, int dstYmin, int width, int height)
| Copy a sub-part of a logical buffer of the framebuffer (color or depth) to the texture object. More...
void | GetShiftAndScale (float &shift, float &scale)
| Get the shift and scale required in the shader to return the texture values to their original range. More...
void | Resize (unsigned int width, unsigned int height)
void | AssignToExistingTexture (unsigned int handle, unsigned int target)
| Assign the TextureObject to a externally provided Handle and Target. More...
void | SetContext (vtkOpenGLRenderWindow *)
| Get/Set the context. More...
vtkOpenGLRenderWindow * | GetContext ()
| Get/Set the context. More...
virtual unsigned int | GetWidth ()
| Get the texture dimensions. More...
virtual unsigned int | GetHeight ()
| Get the texture dimensions. More...
virtual unsigned int | GetDepth ()
| Get the texture dimensions. More...
virtual unsigned int | GetSamples ()
| Get the texture dimensions. More...
virtual int | GetComponents ()
| Get the texture dimensions. More...
unsigned int | GetTuples ()
| Get the texture dimensions. More...
virtual unsigned int | GetTarget ()
| Returns OpenGL texture target to which the texture is/can be bound. More...
virtual unsigned int | GetHandle ()
| Returns the OpenGL handle. More...
void | Bind ()
| Bind the texture, must have been created using Create(). More...
virtual void | SetAutoParameters (int)
| Get/Set AutoParameters flag. More...
virtual int | GetAutoParameters ()
| Get/Set AutoParameters flag. More...
virtual void | AutoParametersOn ()
| Get/Set AutoParameters flag. More...
virtual void | AutoParametersOff ()
| Get/Set AutoParameters flag. More...
bool | Create2D (unsigned int width, unsigned int height, int numComps, int vtktype, bool)
| Create texture without uploading any data. More...
bool | Create3D (unsigned int width, unsigned int height, unsigned int depth, int numComps, int vtktype, bool)
| Create texture without uploading any data. More...
int | GetDataType (int vtk_scalar_type)
| Get the data type for the texture as GLenum type. More...
void | SetDataType (unsigned int glType)
| Get the data type for the texture as GLenum type. More...
int | GetDefaultDataType (int vtk_scalar_type)
| Get the data type for the texture as GLenum type. More...
unsigned int | GetInternalFormat (int vtktype, int numComps, bool shaderSupportsTextureInt)
| Get/Set internal format (OpenGL internal format) that should be used. More...
void | SetInternalFormat (unsigned int glInternalFormat)
| Get/Set internal format (OpenGL internal format) that should be used. More...
unsigned int | GetDefaultInternalFormat (int vtktype, int numComps, bool shaderSupportsTextureInt)
| Get/Set internal format (OpenGL internal format) that should be used. More...
unsigned int | GetFormat (int vtktype, int numComps, bool shaderSupportsTextureInt)
| Get/Set format (OpenGL internal format) that should be used. More...
void | SetFormat (unsigned int glFormat)
| Get/Set format (OpenGL internal format) that should be used. More...
unsigned int | GetDefaultFormat (int vtktype, int numComps, bool shaderSupportsTextureInt)
| Get/Set format (OpenGL internal format) that should be used. More...
virtual void | SetRequireDepthBufferFloat (bool)
| Optional, require support for floating point depth buffer formats. More...
virtual bool | GetRequireDepthBufferFloat ()
| Optional, require support for floating point depth buffer formats. More...
virtual bool | GetSupportsDepthBufferFloat ()
| Optional, require support for floating point depth buffer formats. More...
virtual void | SetRequireTextureFloat (bool)
| Optional, require support for floating point texture formats. More...
virtual bool | GetRequireTextureFloat ()
| Optional, require support for floating point texture formats. More...
virtual bool | GetSupportsTextureFloat ()
| Optional, require support for floating point texture formats. More...
virtual void | SetRequireTextureInteger (bool)
| Optional, require support for integer texture formats. More...
virtual bool | GetRequireTextureInteger ()
| Optional, require support for integer texture formats. More...
virtual bool | GetSupportsTextureInteger ()
| Optional, require support for integer texture formats. More...
virtual int | GetWrapS ()
| Wrap mode for the first texture coordinate "s" Valid values are: More...
virtual void | SetWrapS (int)
| Wrap mode for the first texture coordinate "s" Valid values are: More...
virtual int | GetWrapT ()
| Wrap mode for the first texture coordinate "t" Valid values are: More...
virtual void | SetWrapT (int)
| Wrap mode for the first texture coordinate "t" Valid values are: More...
virtual int | GetWrapR ()
| Wrap mode for the first texture coordinate "r" Valid values are: More...
virtual void | SetWrapR (int)
| Wrap mode for the first texture coordinate "r" Valid values are: More...
virtual int | GetMinificationFilter ()
| Minification filter mode. More...
virtual void | SetMinificationFilter (int)
| Minification filter mode. More...
virtual int | GetMagnificationFilter ()
| Magnification filter mode. More...
virtual void | SetMagnificationFilter (int)
| Magnification filter mode. More...
virtual void | SetBorderColor (float, float, float, float)
| Border Color (RGBA). More...
virtual void | SetBorderColor (float[4])
| Border Color (RGBA). More...
virtual float * | GetBorderColor ()
| Border Color (RGBA). More...
virtual void | GetBorderColor (float &, float &, float &, float &)
| Border Color (RGBA). More...
virtual void | GetBorderColor (float[4])
| Border Color (RGBA). More...
virtual void | SetMinLOD (float)
| Lower-clamp the computed LOD against this value. More...
virtual float | GetMinLOD ()
| Lower-clamp the computed LOD against this value. More...
virtual void | SetMaxLOD (float)
| Upper-clamp the computed LOD against this value. More...
virtual float | GetMaxLOD ()
| Upper-clamp the computed LOD against this value. More...
virtual void | SetBaseLevel (int)
| Level of detail of the first texture image. More...
virtual int | GetBaseLevel ()
| Level of detail of the first texture image. More...
virtual void | SetMaxLevel (int)
| Level of detail of the first texture image. More...
virtual int | GetMaxLevel ()
| Level of detail of the first texture image. More...
virtual bool | GetDepthTextureCompare ()
| Tells if the output of a texture unit with a depth texture uses comparison or not. More...
virtual void | SetDepthTextureCompare (bool)
| Tells if the output of a texture unit with a depth texture uses comparison or not. More...
virtual int | GetDepthTextureCompareFunction ()
| In case DepthTextureCompare is true, specify the comparison function in use. More...
virtual void | SetDepthTextureCompareFunction (int)
| In case DepthTextureCompare is true, specify the comparison function in use. More...
virtual bool | GetGenerateMipmap ()
| Tells the hardware to generate mipmap textures from the first texture image at BaseLevel. More...
virtual void | SetGenerateMipmap (bool)
| Tells the hardware to generate mipmap textures from the first texture image at BaseLevel. More...
virtual void | SetMaximumAnisotropicFiltering (float)
| Set/Get the maximum anisotropic filtering to use. More...
virtual float | GetMaximumAnisotropicFiltering ()
| Set/Get the maximum anisotropic filtering to use. More...
void | CopyToFrameBuffer (vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Copy the texture (src) in the current framebuffer. More...
void | CopyToFrameBuffer (int srcXmin, int srcYmin, int srcXmax, int srcYmax, int dstXmin, int dstYmin, int dstXmax, int dstYmax, int dstSizeX, int dstSizeY, vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Copy the texture (src) in the current framebuffer. More...
void | CopyToFrameBuffer (int srcXmin, int srcYmin, int srcXmax, int srcYmax, int dstXmin, int dstYmin, int dstSizeX, int dstSizeY, vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Copy the texture (src) in the current framebuffer. More...
void | CopyToFrameBuffer (float *tcoords, float *verts, vtkShaderProgram *program, vtkOpenGLVertexArrayObject *vao)
| Copy the texture (src) in the current framebuffer. More...
virtual bool | GetUseSRGBColorSpace ()
| Is this texture using the sRGB color space. More...
virtual void | SetUseSRGBColorSpace (bool)
| Is this texture using the sRGB color space. More...
virtual void | UseSRGBColorSpaceOn ()
| Is this texture using the sRGB color space. More...
virtual void | UseSRGBColorSpaceOff ()
| Is this texture using the sRGB color space. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTextureObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkTextureObject * | SafeDownCast (vtkObjectBase *o)
static bool | IsSupported (vtkOpenGLRenderWindow *, bool, bool, bool)
| Returns if the context supports the required extensions. More...
static bool | IsSupported (vtkOpenGLRenderWindow *)
| Check for feature support, without any optional features. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkTextureObject ()
| ~vtkTextureObject () override
void | CreateTexture ()
| Creates a texture handle if not already created. More...
void | DestroyTexture ()
| Destroy the texture. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkGenericOpenGLResourceFreeCallback * | ResourceCallback
int | NumberOfDimensions
unsigned int | Width
unsigned int | Height
unsigned int | Depth
unsigned int | Samples
bool | UseSRGBColorSpace
float | MaximumAnisotropicFiltering
unsigned int | Target
unsigned int | Format
unsigned int | InternalFormat
unsigned int | Type
int | Components
vtkWeakPointer< vtkOpenGLRenderWindow > | Context
unsigned int | Handle
bool | OwnHandle
bool | RequireTextureInteger
bool | SupportsTextureInteger
bool | RequireTextureFloat
bool | SupportsTextureFloat
bool | RequireDepthBufferFloat
bool | SupportsDepthBufferFloat
int | WrapS
int | WrapT
int | WrapR
int | MinificationFilter
int | MagnificationFilter
float | MinLOD
float | MaxLOD
int | BaseLevel
int | MaxLevel
float | BorderColor [4]
bool | DepthTextureCompare
int | DepthTextureCompareFunction
bool | GenerateMipmap
int | AutoParameters
vtkTimeStamp | SendParametersTime
vtkOpenGLHelper * | ShaderProgram
vtkOpenGLBufferObject * | BufferObject
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
static int | GetMaximumTextureSize (vtkOpenGLRenderWindow *context)
| Query and return maximum texture size (dimension) supported by the OpenGL driver for a particular context. More...
static int | GetMaximumTextureSize3D (vtkOpenGLRenderWindow *context)
| Query and return maximum texture size (dimension) supported by the OpenGL driver for a particular context. More...
int | GetMaximumTextureSize3D ()
| Overload which uses the internal context to query the maximum 3D texture size. More...

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

abstracts an OpenGL texture object.

vtkTextureObject represents an OpenGL texture object. It provides API to create textures using data already loaded into pixel buffer objects. It can also be used to create textures without uploading any data.

Tests:
  vtkTextureObject (Tests)

Definition at line 32 of file vtkTextureObject.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkTextureObject::Superclass

Definition at line 89 of file vtkTextureObject.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
Lequal |
Gequal |
Less |
Greater |
Equal |
NotEqual |
AlwaysTrue |
Never |
NumberOfDepthTextureCompareFunctions |

Definition at line 36 of file vtkTextureObject.h.

## ◆ anonymous enum

anonymous enum

Enumerator
ClampToEdge |
Repeat |
MirroredRepeat |
ClampToBorder |
NumberOfWrapModes |

Definition at line 52 of file vtkTextureObject.h.

## ◆ anonymous enum

anonymous enum

Enumerator
Nearest |
Linear |
NearestMipmapNearest |
NearestMipmapLinear |
LinearMipmapNearest |
LinearMipmapLinear |
NumberOfMinificationModes |

Definition at line 64 of file vtkTextureObject.h.

## ◆ anonymous enum

anonymous enum

Enumerator
Native |
Fixed8 |
Fixed16 |
Fixed24 |
Fixed32 |
Float16 |
Float32 |
NumberOfDepthFormats |

Definition at line 76 of file vtkTextureObject.h.

## Constructor & Destructor Documentation

## ◆ vtkTextureObject()

vtkTextureObject::vtkTextureObject | ( |  | ) |
| protected

## ◆ ~vtkTextureObject()

vtkTextureObject::~vtkTextureObject | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkTextureObject* vtkTextureObject::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkTextureObject::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkTextureObject::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkQWidgetTexture.

## ◆ SafeDownCast()

static vtkTextureObject* vtkTextureObject::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkTextureObject::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkQWidgetTexture.

## ◆ NewInstance()

vtkTextureObject* vtkTextureObject::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkTextureObject::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ SetContext()

void vtkTextureObject::SetContext | ( | vtkOpenGLRenderWindow * |  | ) |

Get/Set the context.

This does not increase the reference count of the context to avoid reference loops.

{ this->TextureObject = vtkTextureObject::New(); }SetContext() may raise an error if the OpenGL context does not support the required OpenGL extensions.

## ◆ GetContext()

vtkOpenGLRenderWindow* vtkTextureObject::GetContext | ( |  | ) |

Get/Set the context.

This does not increase the reference count of the context to avoid reference loops.

{ this->TextureObject = vtkTextureObject::New(); }SetContext() may raise an error if the OpenGL context does not support the required OpenGL extensions.

## ◆ GetWidth()

virtual unsigned int vtkTextureObject::GetWidth | ( |  | ) |
| virtual

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

## ◆ GetHeight()

virtual unsigned int vtkTextureObject::GetHeight | ( |  | ) |
| virtual

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

## ◆ GetDepth()

virtual unsigned int vtkTextureObject::GetDepth | ( |  | ) |
| virtual

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

## ◆ GetSamples()

virtual unsigned int vtkTextureObject::GetSamples | ( |  | ) |
| virtual

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

## ◆ GetComponents()

virtual int vtkTextureObject::GetComponents | ( |  | ) |
| virtual

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

## ◆ GetTuples()

unsigned int vtkTextureObject::GetTuples | ( |  | ) |
| inline

Get the texture dimensions.

These are the properties of the OpenGL texture this instance represents.

Definition at line 116 of file vtkTextureObject.h.

## ◆ GetNumberOfDimensions()

virtual int vtkTextureObject::GetNumberOfDimensions | ( |  | ) |
| virtual

## ◆ SetSamples()

virtual void vtkTextureObject::SetSamples | ( | unsigned int |  | ) |
| virtual

## ◆ GetTarget()

virtual unsigned int vtkTextureObject::GetTarget | ( |  | ) |
| virtual

Returns OpenGL texture target to which the texture is/can be bound.

## ◆ GetHandle()

virtual unsigned int vtkTextureObject::GetHandle | ( |  | ) |
| virtual

Returns the OpenGL handle.

## ◆ GetTextureUnit()

int vtkTextureObject::GetTextureUnit | ( |  | ) |

Return the texture unit used for this texture.

## ◆ Bind()

void vtkTextureObject::Bind | ( |  | ) |

Bind the texture, must have been created using Create().

A side affect is that tex parameters are sent. RenderWindow must be set before calling this.

## ◆ Activate()

virtual void vtkTextureObject::Activate | ( |  | ) |
| virtual

Activate and Bind the texture.

Reimplemented in vtkQWidgetTexture.

## ◆ Deactivate()

void vtkTextureObject::Deactivate | ( |  | ) |

Deactivate and UnBind the texture.

## ◆ ReleaseGraphicsResources()

virtual void vtkTextureObject::ReleaseGraphicsResources | ( | vtkWindow * | win | ) |
| virtual

Deactivate and UnBind the texture.

Reimplemented in vtkQWidgetTexture.

## ◆ IsBound()

bool vtkTextureObject::IsBound | ( |  | ) |

Tells if the texture object is bound to the active texture image unit.

(a texture object can be bound to multiple texture image unit).

## ◆ SendParameters()

void vtkTextureObject::SendParameters | ( |  | ) |

Send all the texture object parameters to the hardware if not done yet.

Parameters are automatically sent as a side affect of Bind. Disable this by setting AutoParameters 0.

Precondition
  is_bound: IsBound()

## ◆ SetAutoParameters()

virtual void vtkTextureObject::SetAutoParameters | ( | int |  | ) |
| virtual

Get/Set AutoParameters flag.

When enabled, SendParameters method is called automatically when the texture is bound.

## ◆ GetAutoParameters()

virtual int vtkTextureObject::GetAutoParameters | ( |  | ) |
| virtual

Get/Set AutoParameters flag.

When enabled, SendParameters method is called automatically when the texture is bound.

## ◆ AutoParametersOn()

virtual void vtkTextureObject::AutoParametersOn | ( |  | ) |
| virtual

Get/Set AutoParameters flag.

When enabled, SendParameters method is called automatically when the texture is bound.

## ◆ AutoParametersOff()

virtual void vtkTextureObject::AutoParametersOff | ( |  | ) |
| virtual

Get/Set AutoParameters flag.

When enabled, SendParameters method is called automatically when the texture is bound.

## ◆ Create2DFromRaw()

bool vtkTextureObject::Create2DFromRaw | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | numComps,
|  | int | dataType,
|  | void * | data
| ) |  |

Create a 2D texture from client memory numComps must be in [1-4].

## ◆ CreateDepthFromRaw()

bool vtkTextureObject::CreateDepthFromRaw | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | internalFormat,
|  | int | rawType,
|  | void * | raw
| ) |  |

Create a 2D depth texture using a raw pointer.

This is a blocking call. If you can, use PBO instead. raw can be null in order to allocate texture without initialization.

## ◆ CreateTextureBuffer()

bool vtkTextureObject::CreateTextureBuffer | ( | unsigned int | numValues,
|  | int | numComps,
|  | int | dataType,
|  | vtkOpenGLBufferObject * | bo
| ) |  |

Create a texture buffer basically a 1D texture that can be very large for passing data into the fragment shader.

## ◆ EmulateTextureBufferWith2DTextures()

bool vtkTextureObject::EmulateTextureBufferWith2DTextures | ( | unsigned int | numValues,
|  | int | numComps,
|  | int | dataType,
|  | vtkOpenGLBufferObject * | bo
| ) |  |

Emulates a texture buffer with 2D texture.

Useful if hardware doesn't support texture buffers. Shader program that use this sampler will need to account for the change in indexing scheme. When VTK is compiled with GLES support, `vtkOpenGLShaderCache::ReplaceShaderValues()` patches the shader code to ensure all uses of 1D texture buffers work as usual.

## ◆ CreateCubeFromRaw()

bool vtkTextureObject::CreateCubeFromRaw | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | numComps,
|  | int | dataType,
|  | void * | data[6]
| ) |  |

Create a cube texture from 6 buffers from client memory.

Image data must be provided in the following order: +X -X +Y -Y +Z -Z. numComps must be in [1-4].

## ◆ Create1D()

bool vtkTextureObject::Create1D | ( | int | numComps,
|  | vtkPixelBufferObject * | pbo,
|  | bool | shaderSupportsTextureInt
| ) |  |

Create a 1D texture using the PBO.

Eventually we may start supporting creating a texture from subset of data in the PBO, but for simplicity we'll begin with entire PBO data. numComps must be in [1-4]. shaderSupportsTextureInt is true if the shader has an alternate implementation supporting sampler with integer values. Even if the card supports texture int, it does not mean that the implementor of the shader made a version that supports texture int.

## ◆ Create1DFromRaw()

bool vtkTextureObject::Create1DFromRaw | ( | unsigned int | width,
|  | int | numComps,
|  | int | dataType,
|  | void * | data
| ) |  |

Create 1D texture from client memory.

## ◆ Create2D() [1/2]

bool vtkTextureObject::Create2D | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | numComps,
|  | vtkPixelBufferObject * | pbo,
|  | bool | shaderSupportsTextureInt
| ) |  |

Create a 2D texture using the PBO.

Eventually we may start supporting creating a texture from subset of data in the PBO, but for simplicity we'll begin with entire PBO data. numComps must be in [1-4].

## ◆ Create3D() [1/2]

bool vtkTextureObject::Create3D | ( | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | depth,
|  | int | numComps,
|  | vtkPixelBufferObject * | pbo,
|  | bool | shaderSupportsTextureInt
| ) |  |

Create a 3D texture using the PBO.

Eventually we may start supporting creating a texture from subset of data in the PBO, but for simplicity we'll begin with entire PBO data. numComps must be in [1-4].

## ◆ Create3DFromRaw()

bool vtkTextureObject::Create3DFromRaw | ( | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | depth,
|  | int | numComps,
|  | int | dataType,
|  | void * | data
| ) |  |

Create a 3D texture from client memory numComps must be in [1-4].

## ◆ AllocateProxyTexture3D()

bool vtkTextureObject::AllocateProxyTexture3D | ( | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | depth,
|  | int | numComps,
|  | int | dataType
| ) |  |

Create a 3D texture using the GL_PROXY_TEXTURE_3D target.

This serves as a pre-allocation step which assists in verifying that the size of the texture to be created is supported by the implementation and that there is sufficient texture memory available for it.

## ◆ Download() [1/2]

vtkPixelBufferObject* vtkTextureObject::Download | ( |  | ) |

This is used to download raw data from the texture into a pixel buffer.

The pixel buffer API can then be used to download the pixel buffer data to CPU arrays. The caller takes on the responsibility of deleting the returns vtkPixelBufferObject once it done with it.

## ◆ Download() [2/2]

vtkPixelBufferObject* vtkTextureObject::Download | ( | unsigned int | target,
|  | unsigned int | level
| ) |  |

## ◆ CreateDepth()

bool vtkTextureObject::CreateDepth | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | internalFormat,
|  | vtkPixelBufferObject * | pbo
| ) |  |

Create a 2D depth texture using a PBO.

Precondition
  : valid_internalFormat: internalFormat>=0 && internalFormat<NumberOfDepthFormats

## ◆ AllocateDepth()

bool vtkTextureObject::AllocateDepth | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | internalFormat
| ) |  |

Create a 2D depth texture but does not initialize its values.

## ◆ AllocateDepthStencil()

bool vtkTextureObject::AllocateDepthStencil | ( | unsigned int | width,
|  | unsigned int | height
| ) |  |

Create a 2D septh stencil texture but does not initialize its values.

## ◆ Allocate1D()

bool vtkTextureObject::Allocate1D | ( | unsigned int | width,
|  | int | numComps,
|  | int | vtkType
| ) |  |

Create a 1D color texture but does not initialize its values.

Internal format is deduced from numComps and vtkType.

## ◆ Allocate2D()

bool vtkTextureObject::Allocate2D | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | numComps,
|  | int | vtkType,
|  | int | level = `0`
| ) |  |

Create a 2D color texture but does not initialize its values.

Internal format is deduced from numComps and vtkType.

## ◆ Allocate3D()

bool vtkTextureObject::Allocate3D | ( | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | depth,
|  | int | numComps,
|  | int | vtkType
| ) |  |

Create a 3D color texture but does not initialize its values.

Internal format is deduced from numComps and vtkType.

## ◆ Create2D() [2/2]

bool vtkTextureObject::Create2D | ( | unsigned int | width,
|  | unsigned int | height,
|  | int | numComps,
|  | int | vtktype,
|  | bool |
| ) |  |
| inline

Create texture without uploading any data.

Definition at line 331 of file vtkTextureObject.h.

## ◆ Create3D() [2/2]

bool vtkTextureObject::Create3D | ( | unsigned int | width,
|  | unsigned int | height,
|  | unsigned int | depth,
|  | int | numComps,
|  | int | vtktype,
|  | bool |
| ) |  |
| inline

Create texture without uploading any data.

Definition at line 335 of file vtkTextureObject.h.

## ◆ GetVTKDataType()

int vtkTextureObject::GetVTKDataType | ( |  | ) |

Get the data type for the texture as a vtk type int i.e.

VTK_INT etc.

## ◆ GetDataType()

int vtkTextureObject::GetDataType | ( | int | vtk_scalar_type | ) |

Get the data type for the texture as GLenum type.

## ◆ SetDataType()

void vtkTextureObject::SetDataType | ( | unsigned int | glType | ) |

Get the data type for the texture as GLenum type.

## ◆ GetDefaultDataType()

int vtkTextureObject::GetDefaultDataType | ( | int | vtk_scalar_type | ) |

Get the data type for the texture as GLenum type.

## ◆ GetInternalFormat()

unsigned int vtkTextureObject::GetInternalFormat | ( | int | vtktype,
|  | int | numComps,
|  | bool | shaderSupportsTextureInt
| ) |  |

Get/Set internal format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ SetInternalFormat()

void vtkTextureObject::SetInternalFormat | ( | unsigned int | glInternalFormat | ) |

Get/Set internal format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ GetDefaultInternalFormat()

unsigned int vtkTextureObject::GetDefaultInternalFormat | ( | int | vtktype,
|  | int | numComps,
|  | bool | shaderSupportsTextureInt
| ) |  |

Get/Set internal format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ GetFormat()

unsigned int vtkTextureObject::GetFormat | ( | int | vtktype,
|  | int | numComps,
|  | bool | shaderSupportsTextureInt
| ) |  |

Get/Set format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ SetFormat()

void vtkTextureObject::SetFormat | ( | unsigned int | glFormat | ) |

Get/Set format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ GetDefaultFormat()

unsigned int vtkTextureObject::GetDefaultFormat | ( | int | vtktype,
|  | int | numComps,
|  | bool | shaderSupportsTextureInt
| ) |  |

Get/Set format (OpenGL internal format) that should be used.

(https://www.opengl.org/sdk/docs/man2/xhtml/glTexImage2D.xml)

## ◆ ResetFormatAndType()

void vtkTextureObject::ResetFormatAndType | ( |  | ) |

Reset format, internal format, and type of the texture.

This method is useful when a texture is reused in a context same as the previous render call. In such cases, texture destruction does not happen and therefore previous set values are used.

## ◆ GetMinificationFilterMode()

unsigned int vtkTextureObject::GetMinificationFilterMode | ( | int | vtktype | ) |

## ◆ GetMagnificationFilterMode()

unsigned int vtkTextureObject::GetMagnificationFilterMode | ( | int | vtktype | ) |

## ◆ GetWrapSMode()

unsigned int vtkTextureObject::GetWrapSMode | ( | int | vtktype | ) |

## ◆ GetWrapTMode()

unsigned int vtkTextureObject::GetWrapTMode | ( | int | vtktype | ) |

## ◆ GetWrapRMode()

unsigned int vtkTextureObject::GetWrapRMode | ( | int | vtktype | ) |

## ◆ SetRequireDepthBufferFloat()

virtual void vtkTextureObject::SetRequireDepthBufferFloat | ( | bool |  | ) |
| virtual

Optional, require support for floating point depth buffer formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetRequireDepthBufferFloat()

virtual bool vtkTextureObject::GetRequireDepthBufferFloat | ( |  | ) |
| virtual

Optional, require support for floating point depth buffer formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetSupportsDepthBufferFloat()

virtual bool vtkTextureObject::GetSupportsDepthBufferFloat | ( |  | ) |
| virtual

Optional, require support for floating point depth buffer formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ SetRequireTextureFloat()

virtual void vtkTextureObject::SetRequireTextureFloat | ( | bool |  | ) |
| virtual

Optional, require support for floating point texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetRequireTextureFloat()

virtual bool vtkTextureObject::GetRequireTextureFloat | ( |  | ) |
| virtual

Optional, require support for floating point texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetSupportsTextureFloat()

virtual bool vtkTextureObject::GetSupportsTextureFloat | ( |  | ) |
| virtual

Optional, require support for floating point texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ SetRequireTextureInteger()

virtual void vtkTextureObject::SetRequireTextureInteger | ( | bool |  | ) |
| virtual

Optional, require support for integer texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetRequireTextureInteger()

virtual bool vtkTextureObject::GetRequireTextureInteger | ( |  | ) |
| virtual

Optional, require support for integer texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetSupportsTextureInteger()

virtual bool vtkTextureObject::GetSupportsTextureInteger | ( |  | ) |
| virtual

Optional, require support for integer texture formats.

If supported extensions will be loaded, however loading will fail if the extension is required but not available.

## ◆ GetWrapS()

virtual int vtkTextureObject::GetWrapS | ( |  | ) |
| virtual

Wrap mode for the first texture coordinate "s" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ SetWrapS()

virtual void vtkTextureObject::SetWrapS | ( | int |  | ) |
| virtual

Wrap mode for the first texture coordinate "s" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ GetWrapT()

virtual int vtkTextureObject::GetWrapT | ( |  | ) |
| virtual

Wrap mode for the first texture coordinate "t" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ SetWrapT()

virtual void vtkTextureObject::SetWrapT | ( | int |  | ) |
| virtual

Wrap mode for the first texture coordinate "t" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ GetWrapR()

virtual int vtkTextureObject::GetWrapR | ( |  | ) |
| virtual

Wrap mode for the first texture coordinate "r" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ SetWrapR()

virtual void vtkTextureObject::SetWrapR | ( | int |  | ) |
| virtual

Wrap mode for the first texture coordinate "r" Valid values are:

- Clamp
- ClampToEdge
- Repeat
- ClampToBorder
- MirroredRepeat Initial value is Repeat (as in OpenGL spec)

## ◆ GetMinificationFilter()

virtual int vtkTextureObject::GetMinificationFilter | ( |  | ) |
| virtual

Minification filter mode.

Valid values are:

- Nearest
- Linear
- NearestMipmapNearest
- NearestMipmapLinear
- LinearMipmapNearest
- LinearMipmapLinear Initial value is Nearest (note initial value in OpenGL spec is NearestMipMapLinear but this is error-prone because it makes the texture object incomplete. ).

## ◆ SetMinificationFilter()

virtual void vtkTextureObject::SetMinificationFilter | ( | int |  | ) |
| virtual

Minification filter mode.

Valid values are:

- Nearest
- Linear
- NearestMipmapNearest
- NearestMipmapLinear
- LinearMipmapNearest
- LinearMipmapLinear Initial value is Nearest (note initial value in OpenGL spec is NearestMipMapLinear but this is error-prone because it makes the texture object incomplete. ).

## ◆ GetMagnificationFilter()

virtual int vtkTextureObject::GetMagnificationFilter | ( |  | ) |
| virtual

Magnification filter mode.

Valid values are:

- Nearest
- Linear Initial value is Nearest

## ◆ SetMagnificationFilter()

virtual void vtkTextureObject::SetMagnificationFilter | ( | int |  | ) |
| virtual

Magnification filter mode.

Valid values are:

- Nearest
- Linear Initial value is Nearest

## ◆ SetLinearMagnification()

void vtkTextureObject::SetLinearMagnification | ( | bool | val | ) |
| inline

Tells if the magnification mode is linear (true) or nearest (false).

Initial value is false (initial value in OpenGL spec is true).

Definition at line 509 of file vtkTextureObject.h.

## ◆ GetLinearMagnification()

bool vtkTextureObject::GetLinearMagnification | ( |  | ) |
| inline

Definition at line 511 of file vtkTextureObject.h.

## ◆ SetBorderColor() [1/2]

virtual void vtkTextureObject::SetBorderColor | ( | float | ,
|  | float | ,
|  | float | ,
|  | float |
| ) |  |
| virtual

Border Color (RGBA).

The values can be any valid float value, if the gpu supports it. Initial value is (0.0f, 0.0f, 0.0f, 0.0f), as in the OpenGL spec.

## ◆ SetBorderColor() [2/2]

virtual void vtkTextureObject::SetBorderColor | ( | float | [4] | ) |
| virtual

Border Color (RGBA).

The values can be any valid float value, if the gpu supports it. Initial value is (0.0f, 0.0f, 0.0f, 0.0f), as in the OpenGL spec.

## ◆ GetBorderColor() [1/3]

virtual float* vtkTextureObject::GetBorderColor | ( |  | ) |
| virtual

Border Color (RGBA).

The values can be any valid float value, if the gpu supports it. Initial value is (0.0f, 0.0f, 0.0f, 0.0f), as in the OpenGL spec.

## ◆ GetBorderColor() [2/3]

virtual void vtkTextureObject::GetBorderColor | ( | float & | ,
|  | float & | ,
|  | float & | ,
|  | float & |
| ) |  |
| virtual

Border Color (RGBA).

The values can be any valid float value, if the gpu supports it. Initial value is (0.0f, 0.0f, 0.0f, 0.0f), as in the OpenGL spec.

## ◆ GetBorderColor() [3/3]

virtual void vtkTextureObject::GetBorderColor | ( | float | [4] | ) |
| virtual

Border Color (RGBA).

The values can be any valid float value, if the gpu supports it. Initial value is (0.0f, 0.0f, 0.0f, 0.0f), as in the OpenGL spec.

## ◆ SetMinLOD()

virtual void vtkTextureObject::SetMinLOD | ( | float |  | ) |
| virtual

Lower-clamp the computed LOD against this value.

Any float value is valid. Initial value is -1000.0f, as in OpenGL spec.

## ◆ GetMinLOD()

virtual float vtkTextureObject::GetMinLOD | ( |  | ) |
| virtual

Lower-clamp the computed LOD against this value.

Any float value is valid. Initial value is -1000.0f, as in OpenGL spec.

## ◆ SetMaxLOD()

virtual void vtkTextureObject::SetMaxLOD | ( | float |  | ) |
| virtual

Upper-clamp the computed LOD against this value.

Any float value is valid. Initial value is 1000.0f, as in OpenGL spec.

## ◆ GetMaxLOD()

virtual float vtkTextureObject::GetMaxLOD | ( |  | ) |
| virtual

Upper-clamp the computed LOD against this value.

Any float value is valid. Initial value is 1000.0f, as in OpenGL spec.

## ◆ SetBaseLevel()

virtual void vtkTextureObject::SetBaseLevel | ( | int |  | ) |
| virtual

Level of detail of the first texture image.

A texture object is a list of texture images. It is a non-negative integer value. Initial value is 0, as in OpenGL spec.

## ◆ GetBaseLevel()

virtual int vtkTextureObject::GetBaseLevel | ( |  | ) |
| virtual

Level of detail of the first texture image.

A texture object is a list of texture images. It is a non-negative integer value. Initial value is 0, as in OpenGL spec.

## ◆ SetMaxLevel()

virtual void vtkTextureObject::SetMaxLevel | ( | int |  | ) |
| virtual

Level of detail of the first texture image.

A texture object is a list of texture images. It is a non-negative integer value. Initial value is 1000, as in OpenGL spec.

## ◆ GetMaxLevel()

virtual int vtkTextureObject::GetMaxLevel | ( |  | ) |
| virtual

Level of detail of the first texture image.

A texture object is a list of texture images. It is a non-negative integer value. Initial value is 1000, as in OpenGL spec.

## ◆ GetDepthTextureCompare()

virtual bool vtkTextureObject::GetDepthTextureCompare | ( |  | ) |
| virtual

Tells if the output of a texture unit with a depth texture uses comparison or not.

Comparison happens between D_t the depth texture value in the range [0,1] and with R the interpolated third texture coordinate clamped to range [0,1]. The result of the comparison is noted ‘r’. If this flag is false, r=D_t. Initial value is false, as in OpenGL spec. Ignored if the texture object is not a depth texture.

## ◆ SetDepthTextureCompare()

virtual void vtkTextureObject::SetDepthTextureCompare | ( | bool |  | ) |
| virtual

Tells if the output of a texture unit with a depth texture uses comparison or not.

Comparison happens between D_t the depth texture value in the range [0,1] and with R the interpolated third texture coordinate clamped to range [0,1]. The result of the comparison is noted ‘r’. If this flag is false, r=D_t. Initial value is false, as in OpenGL spec. Ignored if the texture object is not a depth texture.

## ◆ GetDepthTextureCompareFunction()

virtual int vtkTextureObject::GetDepthTextureCompareFunction | ( |  | ) |
| virtual

In case DepthTextureCompare is true, specify the comparison function in use.

The result of the comparison is noted ‘r’. Valid values are:

- Value
- Lequal: r=R<=Dt ? 1.0 : 0.0
- Gequal: r=R>=Dt ? 1.0 : 0.0
- Less: r=R<D_t ? 1.0 : 0.0
- Greater: r=R>Dt ? 1.0 : 0.0
- Equal: r=R==Dt ? 1.0 : 0.0
- NotEqual: r=R!=Dt ? 1.0 : 0.0
- AlwaysTrue: r=1.0
- Never: r=0.0 If the magnification of minification factor are not nearest, percentage closer filtering (PCF) is used: R is compared to several D_t and r is the average of the comparisons (it is NOT the average of D_t compared once to R). Initial value is Lequal, as in OpenGL spec. Ignored if the texture object is not a depth texture.

## ◆ SetDepthTextureCompareFunction()

virtual void vtkTextureObject::SetDepthTextureCompareFunction | ( | int |  | ) |
| virtual

In case DepthTextureCompare is true, specify the comparison function in use.

The result of the comparison is noted ‘r’. Valid values are:

- Value
- Lequal: r=R<=Dt ? 1.0 : 0.0
- Gequal: r=R>=Dt ? 1.0 : 0.0
- Less: r=R<D_t ? 1.0 : 0.0
- Greater: r=R>Dt ? 1.0 : 0.0
- Equal: r=R==Dt ? 1.0 : 0.0
- NotEqual: r=R!=Dt ? 1.0 : 0.0
- AlwaysTrue: r=1.0
- Never: r=0.0 If the magnification of minification factor are not nearest, percentage closer filtering (PCF) is used: R is compared to several D_t and r is the average of the comparisons (it is NOT the average of D_t compared once to R). Initial value is Lequal, as in OpenGL spec. Ignored if the texture object is not a depth texture.

## ◆ GetGenerateMipmap()

virtual bool vtkTextureObject::GetGenerateMipmap | ( |  | ) |
| virtual

Tells the hardware to generate mipmap textures from the first texture image at BaseLevel.

Initial value is false, as in OpenGL spec.

## ◆ SetGenerateMipmap()

virtual void vtkTextureObject::SetGenerateMipmap | ( | bool |  | ) |
| virtual

Tells the hardware to generate mipmap textures from the first texture image at BaseLevel.

Initial value is false, as in OpenGL spec.

## ◆ SetMaximumAnisotropicFiltering()

virtual void vtkTextureObject::SetMaximumAnisotropicFiltering | ( | float |  | ) |
| virtual

Set/Get the maximum anisotropic filtering to use.

1.0 means use no anisotropic filtering. The default value is 1.0 and a high value would be 16. This might not be supported on all machines.

## ◆ GetMaximumAnisotropicFiltering()

virtual float vtkTextureObject::GetMaximumAnisotropicFiltering | ( |  | ) |
| virtual

Set/Get the maximum anisotropic filtering to use.

1.0 means use no anisotropic filtering. The default value is 1.0 and a high value would be 16. This might not be supported on all machines.

## ◆ GetMaximumTextureSize()

static int vtkTextureObject::GetMaximumTextureSize | ( | vtkOpenGLRenderWindow * | context | ) |
| static

Query and return maximum texture size (dimension) supported by the OpenGL driver for a particular context.

It should be noted that this size does not consider the internal format of the texture and therefore there is no guarantee that a texture of this size will be allocated by the driver. Also, the method does not make the context current so if the passed context is not valid or current, a value of -1 will be returned.

## ◆ GetMaximumTextureSize3D() [1/2]

static int vtkTextureObject::GetMaximumTextureSize3D | ( | vtkOpenGLRenderWindow * | context | ) |
| static

Query and return maximum texture size (dimension) supported by the OpenGL driver for a particular context.

It should be noted that this size does not consider the internal format of the texture and therefore there is no guarantee that a texture of this size will be allocated by the driver. Also, the method does not make the context current so if the passed context is not valid or current, a value of -1 will be returned.

## ◆ GetMaximumTextureSize3D() [2/2]

int vtkTextureObject::GetMaximumTextureSize3D | ( |  | ) |

Overload which uses the internal context to query the maximum 3D texture size.

Will make the internal context current, returns -1 if anything fails.

## ◆ IsSupported() [1/2]

static bool vtkTextureObject::IsSupported | ( | vtkOpenGLRenderWindow * | ,
|  | bool | ,
|  | bool | ,
|  | bool |
| ) |  |
| inlinestatic

Returns if the context supports the required extensions.

If flags for optional extensions are set then the test fails when support for them is not found.

Definition at line 647 of file vtkTextureObject.h.

## ◆ IsSupported() [2/2]

static bool vtkTextureObject::IsSupported | ( | vtkOpenGLRenderWindow * |  | ) |
| inlinestatic

Check for feature support, without any optional features.

Definition at line 656 of file vtkTextureObject.h.

## ◆ CopyToFrameBuffer() [1/4]

void vtkTextureObject::CopyToFrameBuffer | ( | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |

Copy the texture (src) in the current framebuffer.

A variety of signatures based on what you want to do Copy the entire texture to the entire current viewport

## ◆ CopyToFrameBuffer() [2/4]

void vtkTextureObject::CopyToFrameBuffer | ( | int | srcXmin,
|  | int | srcYmin,
|  | int | srcXmax,
|  | int | srcYmax,
|  | int | dstXmin,
|  | int | dstYmin,
|  | int | dstXmax,
|  | int | dstYmax,
|  | int | dstSizeX,
|  | int | dstSizeY,
|  | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |

Copy the texture (src) in the current framebuffer.

A variety of signatures based on what you want to do Copy the entire texture to the entire current viewport

## ◆ CopyToFrameBuffer() [3/4]

void vtkTextureObject::CopyToFrameBuffer | ( | int | srcXmin,
|  | int | srcYmin,
|  | int | srcXmax,
|  | int | srcYmax,
|  | int | dstXmin,
|  | int | dstYmin,
|  | int | dstSizeX,
|  | int | dstSizeY,
|  | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |

Copy the texture (src) in the current framebuffer.

A variety of signatures based on what you want to do Copy the entire texture to the entire current viewport

## ◆ CopyToFrameBuffer() [4/4]

void vtkTextureObject::CopyToFrameBuffer | ( | float * | tcoords,
|  | float * | verts,
|  | vtkShaderProgram * | program,
|  | vtkOpenGLVertexArrayObject * | vao
| ) |  |

Copy the texture (src) in the current framebuffer.

A variety of signatures based on what you want to do Copy the entire texture to the entire current viewport

## ◆ CopyFromFrameBuffer()

void vtkTextureObject::CopyFromFrameBuffer | ( | int | srcXmin,
|  | int | srcYmin,
|  | int | dstXmin,
|  | int | dstYmin,
|  | int | width,
|  | int | height
| ) |  |

Copy a sub-part of a logical buffer of the framebuffer (color or depth) to the texture object.

src is the framebuffer, dst is the texture. (srcXmin,srcYmin) is the location of the lower left corner of the rectangle in the framebuffer. (dstXmin,dstYmin) is the location of the lower left corner of the rectangle in the texture. width and height specifies the size of the rectangle in pixels. If the logical buffer is a color buffer, it has to be selected first with glReadBuffer().

Precondition
  is2D: GetNumberOfDimensions()==2

## ◆ GetShiftAndScale()

void vtkTextureObject::GetShiftAndScale | ( | float & | shift,
|  | float & | scale
| ) |  |

Get the shift and scale required in the shader to return the texture values to their original range.

This is useful when for example you have unsigned char data and it is being accessed using the floating point texture calls. In that case OpenGL maps the uchar range to a different floating point range under the hood. Applying the shift and scale will return the data to its original values in the shader. The texture's internal format must be set before calling these routines. Creating the texture does set it.

## ◆ Resize()

void vtkTextureObject::Resize | ( | unsigned int | width,
|  | unsigned int | height
| ) |  |

## ◆ GetUseSRGBColorSpace()

virtual bool vtkTextureObject::GetUseSRGBColorSpace | ( |  | ) |
| virtual

Is this texture using the sRGB color space.

If you are using a sRGB framebuffer or window then you probably also want to be using sRGB color textures for proper handling of gamma and associated color mixing.

## ◆ SetUseSRGBColorSpace()

virtual void vtkTextureObject::SetUseSRGBColorSpace | ( | bool |  | ) |
| virtual

Is this texture using the sRGB color space.

If you are using a sRGB framebuffer or window then you probably also want to be using sRGB color textures for proper handling of gamma and associated color mixing.

## ◆ UseSRGBColorSpaceOn()

virtual void vtkTextureObject::UseSRGBColorSpaceOn | ( |  | ) |
| virtual

Is this texture using the sRGB color space.

If you are using a sRGB framebuffer or window then you probably also want to be using sRGB color textures for proper handling of gamma and associated color mixing.

## ◆ UseSRGBColorSpaceOff()

virtual void vtkTextureObject::UseSRGBColorSpaceOff | ( |  | ) |
| virtual

Is this texture using the sRGB color space.

If you are using a sRGB framebuffer or window then you probably also want to be using sRGB color textures for proper handling of gamma and associated color mixing.

## ◆ AssignToExistingTexture()

void vtkTextureObject::AssignToExistingTexture | ( | unsigned int | handle,
|  | unsigned int | target
| ) |  |

Assign the TextureObject to a externally provided Handle and Target.

This class will not delete the texture referenced by the handle upon releasing. That is up to whoever created it originally. Note that activating and binding will work. Properties such as wrap/interpolate will also work. But width/height/format etc are left unset.

## ◆ CreateTexture()

void vtkTextureObject::CreateTexture | ( |  | ) |
| protected

Creates a texture handle if not already created.

## ◆ DestroyTexture()

void vtkTextureObject::DestroyTexture | ( |  | ) |
| protected

Destroy the texture.

## Member Data Documentation

## ◆ ResourceCallback

vtkGenericOpenGLResourceFreeCallback* vtkTextureObject::ResourceCallback
| protected

Definition at line 736 of file vtkTextureObject.h.

## ◆ NumberOfDimensions

int vtkTextureObject::NumberOfDimensions
| protected

Definition at line 748 of file vtkTextureObject.h.

## ◆ Width

unsigned int vtkTextureObject::Width
| protected

Definition at line 749 of file vtkTextureObject.h.

## ◆ Height

unsigned int vtkTextureObject::Height
| protected

Definition at line 750 of file vtkTextureObject.h.

## ◆ Depth

unsigned int vtkTextureObject::Depth
| protected

Definition at line 751 of file vtkTextureObject.h.

## ◆ Samples

unsigned int vtkTextureObject::Samples
| protected

Definition at line 752 of file vtkTextureObject.h.

## ◆ UseSRGBColorSpace

bool vtkTextureObject::UseSRGBColorSpace
| protected

Definition at line 753 of file vtkTextureObject.h.

## ◆ MaximumAnisotropicFiltering

float vtkTextureObject::MaximumAnisotropicFiltering
| protected

Definition at line 755 of file vtkTextureObject.h.

## ◆ Target

unsigned int vtkTextureObject::Target
| protected

Definition at line 757 of file vtkTextureObject.h.

## ◆ Format

unsigned int vtkTextureObject::Format
| protected

Definition at line 758 of file vtkTextureObject.h.

## ◆ InternalFormat

unsigned int vtkTextureObject::InternalFormat
| protected

Definition at line 759 of file vtkTextureObject.h.

## ◆ Type

unsigned int vtkTextureObject::Type
| protected

Definition at line 760 of file vtkTextureObject.h.

## ◆ Components

int vtkTextureObject::Components
| protected

Definition at line 761 of file vtkTextureObject.h.

## ◆ Context

vtkWeakPointer<vtkOpenGLRenderWindow> vtkTextureObject::Context
| protected

Definition at line 763 of file vtkTextureObject.h.

## ◆ Handle

unsigned int vtkTextureObject::Handle
| protected

Definition at line 764 of file vtkTextureObject.h.

## ◆ OwnHandle

bool vtkTextureObject::OwnHandle
| protected

Definition at line 765 of file vtkTextureObject.h.

## ◆ RequireTextureInteger

bool vtkTextureObject::RequireTextureInteger
| protected

Definition at line 766 of file vtkTextureObject.h.

## ◆ SupportsTextureInteger

bool vtkTextureObject::SupportsTextureInteger
| protected

Definition at line 767 of file vtkTextureObject.h.

## ◆ RequireTextureFloat

bool vtkTextureObject::RequireTextureFloat
| protected

Definition at line 768 of file vtkTextureObject.h.

## ◆ SupportsTextureFloat

bool vtkTextureObject::SupportsTextureFloat
| protected

Definition at line 769 of file vtkTextureObject.h.

## ◆ RequireDepthBufferFloat

bool vtkTextureObject::RequireDepthBufferFloat
| protected

Definition at line 770 of file vtkTextureObject.h.

## ◆ SupportsDepthBufferFloat

bool vtkTextureObject::SupportsDepthBufferFloat
| protected

Definition at line 771 of file vtkTextureObject.h.

## ◆ WrapS

int vtkTextureObject::WrapS
| protected

Definition at line 773 of file vtkTextureObject.h.

## ◆ WrapT

int vtkTextureObject::WrapT
| protected

Definition at line 774 of file vtkTextureObject.h.

## ◆ WrapR

int vtkTextureObject::WrapR
| protected

Definition at line 775 of file vtkTextureObject.h.

## ◆ MinificationFilter

int vtkTextureObject::MinificationFilter
| protected

Definition at line 776 of file vtkTextureObject.h.

## ◆ MagnificationFilter

int vtkTextureObject::MagnificationFilter
| protected

Definition at line 777 of file vtkTextureObject.h.

## ◆ MinLOD

float vtkTextureObject::MinLOD
| protected

Definition at line 779 of file vtkTextureObject.h.

## ◆ MaxLOD

float vtkTextureObject::MaxLOD
| protected

Definition at line 780 of file vtkTextureObject.h.

## ◆ BaseLevel

int vtkTextureObject::BaseLevel
| protected

Definition at line 781 of file vtkTextureObject.h.

## ◆ MaxLevel

int vtkTextureObject::MaxLevel
| protected

Definition at line 782 of file vtkTextureObject.h.

## ◆ BorderColor

float vtkTextureObject::BorderColor[4]
| protected

Definition at line 783 of file vtkTextureObject.h.

## ◆ DepthTextureCompare

bool vtkTextureObject::DepthTextureCompare
| protected

Definition at line 785 of file vtkTextureObject.h.

## ◆ DepthTextureCompareFunction

int vtkTextureObject::DepthTextureCompareFunction
| protected

Definition at line 786 of file vtkTextureObject.h.

## ◆ GenerateMipmap

bool vtkTextureObject::GenerateMipmap
| protected

Definition at line 788 of file vtkTextureObject.h.

## ◆ AutoParameters

int vtkTextureObject::AutoParameters
| protected

Definition at line 790 of file vtkTextureObject.h.

## ◆ SendParametersTime

vtkTimeStamp vtkTextureObject::SendParametersTime
| protected

Definition at line 791 of file vtkTextureObject.h.

## ◆ ShaderProgram

vtkOpenGLHelper* vtkTextureObject::ShaderProgram
| protected

Definition at line 794 of file vtkTextureObject.h.

## ◆ BufferObject

vtkOpenGLBufferObject* vtkTextureObject::BufferObject
| protected

Definition at line 797 of file vtkTextureObject.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkTextureObject.h